# Concept:

* Inject rsvp, renderJS and jIO into the default jupyter page (after it is rendered) and manually bootstrap renderJS. Entrypoint is jiocontents.js which is loaded by jupyter as part of the nbextension
* This injection is done with the mother-gadget gadget_jupyter_page which has the subgadget gadget_jiocontents responsible for handling the API calls which come from jupyter to the jiocontentsmanager

## Exmaple of API call processing:

1. User presses "Create New Notebook Button" and fills in the form
2. Jupyter internally calls the contents API which is rerouted to this javascript nbextension "jiocontents"
3. The function `Contents.prototype.new_untitled` is called
4. We wait for the waitForReadyPromise resolve (resolves once renderJS injection is complete) or reject after a timeout of 3s
5. A custom event is dispatched to the gadget_jiocontents gadget which has access to JIO containing the information jupyter provides (here only the path of the directory from which the new notebook was created). 
Additionally we supply handles to the resolve / reject functions of the wrapping promise so gadget_jiocontents can resolve the wrapping promise after the information was exchanged with JIO 
6. In gadget_jiocontents we create an empty notebook json and jio.post it to ERP5
7. If this JIO action succeedes, we resolve the wrapping promise with the notebook json which is then further processed internally by jupyter

All jupyter-actions are processed in this way. We create a wrapping promise and pass the work on to gadget_jiocontents, which communicates via JIO and resolves/rejects
this promise based on the communication with the ERP5.


# Important Notes

* It is required to overwrite NotebookApp.contents_manager_class to avoid a
immediate redirect to 404 page upon notebook-loading. Currently this is done
inline in jupyter_notebook_config.py, but should better be moved to a seperate
python file and imported in the config. However, I was unable to get the include
paths right with slapos.

* A lot of weirdness comes with loading notebooks into the page. de-stringyfied
JSONs must be further processed because of unlined-strings. See 
https://github.com/jupyter/jupyter-drive/blob/master/jupyterdrive/gdrive/notebook_model.js#L45  
https://github.com/jupyter/jupyter-drive/pull/124